locals @@
.386p

code32	segment para public use32
assume cs:code32,ds:code32

;=============================================================================
;				   DATA
;=============================================================================

include pmode.inc
include file.inc
include putdos.rt

align	4

public _main

SetBK	macro r,g,b
	pusha
	mov dx,03C8h
	xor ax,ax
	out dx,al
	inc dx
	mov al,r
	out dx,al
	mov al,g
	out dx,al
	mov al,b
	out dx,al
	popa
	endm

_main:
	jmp   RealMain

align 4

TMap	db    320*200 dup (0)	    ; Weight map
Next	dw    320*200 dup (0)	    ; Next pixel of same code
First	dw    256 dup (0)	    ; First pixel of a code
Map1	db    320*200 dup (0)	    ; Work buffer 1
Map2	db    320*200 dup (0)	    ; Work buffer 2
PostTab db    (255*9+1)*9 dup (0)   ; Postconditiong tables
PTab	dd    9 dup (0) 	    ; Address of i-th postconditiong table

seed	dw    06502h

rand	proc near
	push eax
	push ebx
	push ecx
	mov  ecx,1
	xor  edx,edx
@@1:
	mov  bx,seed
	mov  ax,bx
	shr  ax,3
	xor  bx,ax
	shr  ax,1
	xor  bx,ax
	shr  ax,1
	xor  bx,ax
	xor  bl,1
	shr  bx,1
	rcr  seed,1
	rcl  dl,1
	loop @@1
	pop  ecx
	pop  ebx
	pop  eax
	ret
rand	endp

delta dd 0

	;
	; Compute the postconditiong tables
	;
CalcPTab proc near
	pushad
	mov delta,eax
	mov ebx,1
	mov edi,0
@@Loop:
	mov PTab[(ebx*4)-4],edi       ; Save table address
	mov ecx,0
@@Loop1:
	mov eax,ecx
	add eax,delta
	cdq
	idiv ebx
	cmp eax,0
	jge @@NoNeg
	mov eax,0
@@NoNeg:
	cmp eax,255
	jle @@NoMax
	mov eax,255
@@NoMax:
	mov PostTab[edi],al
	inc edi
	inc ecx
	cmp ecx,255*9+1
	jne @@Loop1
	inc ebx
	cmp ebx,10
	jne @@Loop
	popad
	ret
CalcPTab endp

;-------------------------------------------------------

SetAdd macro n
      push esi
@@BitLoop&n:
      inc ecx
      shl al,1
      jnc @@BitLoop&n
      mov esi,Addrs[ecx*4]
      add esi,offset Map1
      mov dword ptr [@@Add&n+3],esi
      pop esi
      endm

Addrs dd -321,-320,-319,-1,1,319,320,321

Rout0 proc near
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout0 endp

Rout1 proc near
      mov ecx,-1
      mov eax,ebx
      SetAdd 1
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
@@Add1:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout1 endp

Rout2 proc near
      mov ecx,-1
      mov eax,ebx
      SetAdd 1
      SetAdd 2
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
@@Add1:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add2:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout2 endp

Rout3 proc near

      mov ecx,-1
      mov eax,ebx
      SetAdd 1
      SetAdd 2
      SetAdd 3
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
@@Add1:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add2:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add3:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout3 endp

Rout4 proc near
      mov ecx,-1
      mov eax,ebx
      SetAdd 1
      SetAdd 2
      SetAdd 3
      SetAdd 4
      xor ecx,ecx
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
@@Add1:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add2:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add3:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add4:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout4 endp

Rout5 proc near
      mov ecx,-1
      mov eax,ebx
      SetAdd 1
      SetAdd 2
      SetAdd 3
      SetAdd 4
      SetAdd 5
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
@@Add1:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add2:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add3:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add4:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add5:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout5 endp

Rout6 proc near
      mov ecx,-1
      mov eax,ebx
      SetAdd 1
      SetAdd 2
      SetAdd 3
      SetAdd 4
      SetAdd 5
      SetAdd 6
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
@@Add1:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add2:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add3:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add4:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add5:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add6:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout6 endp

Rout7 proc near
      mov ecx,-1
      mov eax,ebx
      SetAdd 1
      SetAdd 2
      SetAdd 3
      SetAdd 4
      SetAdd 5
      SetAdd 6
      SetAdd 7
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
@@Add1:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add2:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add3:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add4:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add5:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add6:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0
@@Add7:
      add al,Map1[ecx+esi+012345678h]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout7 endp

Rout8 proc near
      movzx ecx,First[ebx*2]
      cmp cx,-1
      je  @@Done
@@Loop:
      movzx eax,Map1[ecx+esi]
      add al,Map1[ecx+esi-321]
      adc ah,0
      add al,Map1[ecx+esi-320]
      adc ah,0
      add al,Map1[ecx+esi-319]
      adc ah,0
      add al,Map1[ecx+esi-1]
      adc ah,0
      add al,Map1[ecx+esi+1]
      adc ah,0
      add al,Map1[ecx+esi+319]
      adc ah,0
      add al,Map1[ecx+esi+320]
      adc ah,0
      add al,Map1[ecx+esi+321]
      adc ah,0

      mov al,PostTab[edx+eax]
      mov Map1[ecx+edi],al
      mov [ecx+ebp],al
      movzx ecx,Next[ecx*2]
      cmp cx,-1
      jne @@Loop
@@Done:
      ret
Rout8 endp

;-------------------------------------------------------

RealMain:
	;
	; Just a try
	;

	sti
	push  ds
	pop   es
	cld

	mov v86r_ax,0013h
	mov ax,10h
	int 33h

	;
	; Set the palette stuff
	;
	mov dx,03C8h
	xor eax,eax
	out dx,al
	inc dx
@@PalLoop:
	mov al,ah
	shr al,1
	cmp al,63
	jbe @@ROk
	mov al,63
@@ROk:
	out dx,al

	mov al,ah
	shr al,1
	sub al,32
	jge @@GOk
	mov al,0
@@GOk:
	cmp al,63
	jbe @@GOk2
	mov al,63
@@GOk2:
	out dx,al

	mov al,ah
	shr al,1
	sub al,48
	jge @@BOk
	mov al,0
@@BOk:
	cmp al,63
	jbe @@BOk2
	mov al,63
@@BOk2:
	out dx,al

	inc ah
	jne @@PalLoop

	;
	; Compute the weight map
	;
	xor ecx,ecx	    ; ecx = write ptr
	mov edi,200	    ; edi = Y
@@Loop1:
	mov esi,320	    ; esi = X
@@Loop2:
	mov eax,esi	    ; m=((x-160)^2+(y-100)^2)/142
	sub eax,160
	imul eax,eax
	mov ebx,edi
	sub ebx,100
	imul ebx,ebx
	add eax,ebx
	cdq
	mov ebx,142
	idiv ebx
	call rand
	add al,dl
	mov TMap[ecx],al
	inc ecx
	dec esi
	jne @@Loop2
	dec edi
	jne @@Loop1

	;
	; Compute the lists of pixels
	;
	mov edi,255
	mov ax,-1
@@Next0:
	mov First[edi*2],ax
	dec edi
	jge @@Next0

	mov ebx,1		; ebx = Y
@@LoopY:
	mov edx,1		; edx = X
@@LoopX:
	mov esi,0		; esi = bit mask
	mov edi,ebx		; edi = pixel addr
	imul edi,320
	add edi,edx
	mov al,TMap[edi]
	cmp al,TMap[edi-321]	; top left
	cmc
	rcl esi,1
	cmp al,TMap[edi-320]	; top
	cmc
	rcl esi,1
	cmp al,TMap[edi-319]	; top right
	cmc
	rcl esi,1
	cmp al,TMap[edi-1]	; left
	cmc
	rcl esi,1
	cmp al,TMap[edi+1]	; right
	cmc
	rcl esi,1
	cmp al,TMap[edi+319]	; bottom left
	cmc
	rcl esi,1
	cmp al,TMap[edi+320]	; bottom
	cmc
	rcl esi,1
	cmp al,TMap[edi+321]	; bottom right
	cmc
	rcl esi,1
	;
	; Chain the pixel to the correct list
	;
	mov ax,First[esi*2]
	mov Next[edi*2],ax
	mov First[esi*2],di

	;
	; Until end of map
	;
	inc edx
	cmp edx,319
	jne @@LoopX
	inc ebx
	cmp ebx,199
	jne @@LoopY

;	 ;
;	 ; Test the lists
;	 ;
;	 mov ebp,0A0000h
;	 sub ebp,_code32a
;	 mov edi,0
;@@Test0:
;	 call rand
;	 shl dl,7
;	 mov [ebp+edi],dl
;	 inc edi
;	 cmp edi,64000
;	 jne @@Test0
;	 mov ebx,0
;@@Test1:
;	 movzx ecx,First[ebx*2]
;@@Test2:
;	 cmp cx,-1
;	 je @@Test3
;	 mov byte ptr [ecx+ebp],bl
;	 movzx ecx,Next[ecx*2]
;	 jmp @@Test2
;@@Test3:
;	 inc bl
;	 jne @@Test1
;@@TestQ:
;	 mov v86r_ax,0000h
;	 mov ax,16h
;	 int 33h

	;
	; Clear the working buffers
	;
	mov edi,offset Map1
	mov ecx,320*200*2/4
	xor eax,eax
	rep stosd

	mov eax,4
	call CalcPTab

;	 mov edi,0
;@@Test9:
;	 call rand
;	 shl dl,7
;	 mov [ebp+edi],dl
;	 inc edi
;	 cmp edi,64000
;	 jne @@Test9
;
	;
	; Let's go!
	;
	xor esi,esi		    ; esi = source buffer
	mov edi,320*200 	    ; edi = destination buffer
	mov ebp,0A0000h
	sub ebp,_code32a	    ; ebp = screen
@@MainLoop:
	mov ebx,0		    ; ebx = code pointer
@@MLoop1:
	;
	; Count the number of '1' bits of ebx
	;
	xor eax,eax
	mov ecx,ebx
@@BitCount:
	shr ecx,1
	adc eax,0
	cmp ecx,0
	jne @@BitCount

	;
	; Set up the addresses
	;
	mov edx,PTab[eax*4]	; Get the postconditiong table address

	irp a,0,1,2,3,4,5,6,7,8
	cmp eax,&a
	jne @@NoRout&a
	call Rout&a
	jmp @@Called
@@NoRout&a:
	endm
@@Called:
	inc bl
	jne @@MLoop1

;	 call rand
;	 and  edx,3
;	 shl  edx,4
;	 add  edx,100*320+160-16
;	 mov  Map1[edi+edx],255

	xchg esi,edi
	in  al,060h
	cmp al,081h
	jne @@MainLoop

@@Exit1:
	mov v86r_ax,0000h
	mov ax,16h
	int 33h
	mov v86r_ax,0003h
	mov ax,10h
	int 33h

AllDone:

	jmp   _exit

code32	ends
	end
